<?php

declare(strict_types=1);

namespace App\Policies;

use App\Models\SubClassification;
use Illuminate\Auth\Access\HandlesAuthorization;
use Illuminate\Foundation\Auth\User as AuthUser;

class SubClassificationPolicy
{
    use HandlesAuthorization;

    public function viewAny(AuthUser $authUser): bool
    {
        return $authUser->can('ViewAny:SubClassification');
    }

    public function view(AuthUser $authUser, SubClassification $subClassification): bool
    {
        return $authUser->can('View:SubClassification');
    }

    public function create(AuthUser $authUser): bool
    {
        return $authUser->can('Create:SubClassification');
    }

    public function update(AuthUser $authUser, SubClassification $subClassification): bool
    {
        return $authUser->can('Update:SubClassification');
    }

    public function delete(AuthUser $authUser, SubClassification $subClassification): bool
    {
        return $authUser->can('Delete:SubClassification');
    }

    public function restore(AuthUser $authUser, SubClassification $subClassification): bool
    {
        return $authUser->can('Restore:SubClassification');
    }

    public function forceDelete(AuthUser $authUser, SubClassification $subClassification): bool
    {
        return $authUser->can('ForceDelete:SubClassification');
    }

    public function forceDeleteAny(AuthUser $authUser): bool
    {
        return $authUser->can('ForceDeleteAny:SubClassification');
    }

    public function restoreAny(AuthUser $authUser): bool
    {
        return $authUser->can('RestoreAny:SubClassification');
    }

    public function replicate(AuthUser $authUser, SubClassification $subClassification): bool
    {
        return $authUser->can('Replicate:SubClassification');
    }

    public function reorder(AuthUser $authUser): bool
    {
        return $authUser->can('Reorder:SubClassification');
    }
}
